import { notification, Select } from "antd";
import React, { useEffect, useState } from "react";
import { useMutation } from "@apollo/client";
import { useTranslation } from "react-i18next";
import { connect } from "react-redux";
import { createStructuredSelector } from "reselect";
import { UPDATE_JOB_LINE } from "../../graphql/jobs-lines.queries";
import { selectBodyshop } from "../../redux/user/user.selectors";
import LoadingSpinner from "../loading-spinner/loading-spinner.component";

const mapStateToProps = createStructuredSelector({
  //currentUser: selectCurrentUser
  bodyshop: selectBodyshop
});
const mapDispatchToProps = (dispatch) => ({
  //setUserLanguage: language => dispatch(setUserLanguage(language))
});

export function JobLineStatusPopup({ bodyshop, jobline, disabled }) {
  const [editing, setEditing] = useState(false);
  const [loading, setLoading] = useState(false);
  const [status, setStatus] = useState(jobline.status);
  const [updateJob] = useMutation(UPDATE_JOB_LINE);
  const { t } = useTranslation();

  useEffect(() => {
    if (editing) setStatus(jobline.status);
  }, [editing, jobline.status]);

  const handleChange = (e) => {
    setStatus(e);
  };

  const handleSave = async (e) => {
    setLoading(true);
    const result = await updateJob({
      variables: { lineId: jobline.id, line: { status: status || "" } }
    });

    if (!!!result.errors) {
      notification["success"]({ message: t("joblines.successes.saved") });
    } else {
      notification["error"]({
        message: t("joblines.errors.saving", {
          error: JSON.stringify(result.errors)
        })
      });
    }
    setLoading(false);
    setEditing(false);
  };

  if (editing)
    return (
      <div>
        <LoadingSpinner loading={loading}>
          <Select
            autoFocus
            allowClear
            popupMatchSelectWidth={100}
            value={status}
            onSelect={handleChange}
            onBlur={handleSave}
            onClear={() => handleChange(null)}
          >
            {Object.values(bodyshop.md_order_statuses).map((s, idx) => (
              <Select.Option key={idx} value={s}>
                {s}
              </Select.Option>
            ))}
          </Select>
        </LoadingSpinner>
      </div>
    );
  return (
    <div style={{ width: "100%", minHeight: "1rem", cursor: "pointer" }} onClick={() => !disabled && setEditing(true)}>
      {jobline.status}
    </div>
  );
}

export default connect(mapStateToProps, mapDispatchToProps)(JobLineStatusPopup);
